package com.alihealth.d2d.provtest.service.handle.business;

import com.alihealth.d2d.provtest.domain.PharmaceuticalProductionLicenseBaseInfo;
import com.alihealth.d2d.provtest.entity.EventBody;
import com.alihealth.d2d.provtest.entity.InstanceDetail;
import com.alihealth.d2d.provtest.entity.ItemDetail;
import com.alihealth.d2d.provtest.entity.VTTSBasic;
import com.alihealth.d2d.provtest.service.IPharmaceuticalProductionLicenseBaseInfoService;
import com.alihealth.d2d.provtest.service.impl.XmlParserServiceImpl;
import com.alihealth.d2d.provtest.service.handle.AbstractEventDataHandler;
import com.alihealth.d2d.provtest.service.handle.EventSubType;
import com.baomidou.mybatisplus.extension.service.IService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author Jason 药品生产许可证基本信息数据子集
 * @date 2025年06月05日 11:14:43
 */
@Service
@EventSubType("1013")
public class SubType1013Handler extends AbstractEventDataHandler<PharmaceuticalProductionLicenseBaseInfo> {
    protected final Logger log = LoggerFactory.getLogger(getClass());

    @Autowired
    private IPharmaceuticalProductionLicenseBaseInfoService service;

    @Autowired
    private XmlParserServiceImpl xmlParserServiceImpl;

    @Override
    protected Class<PharmaceuticalProductionLicenseBaseInfo> getEntityClass() {
        return PharmaceuticalProductionLicenseBaseInfo.class;
    }

    @Override
    protected IService<PharmaceuticalProductionLicenseBaseInfo> getService() {
        return service;
    }

    @Override
    protected PharmaceuticalProductionLicenseBaseInfo convertToEntity(EventBody eventBody, ItemDetail item, InstanceDetail instance) {
        return null;
    }

    @Override
    public String getSubType() {
        return "1013";
    }

    @Override
    public void handleBase(String xml,String eventId) {
        VTTSBasic<PharmaceuticalProductionLicenseBaseInfo> result = xmlParserServiceImpl.parseDataXml(
                    xml,
                PharmaceuticalProductionLicenseBaseInfo.class
            );
        List<PharmaceuticalProductionLicenseBaseInfo> list = result.getDataset();
        if(list!=null && !list.isEmpty()){
            list.stream()
                    .forEach(item -> {
                        item.setEventId(eventId);
                    });
            getService().saveBatch(list);
            log.info("数据类型："+getSubType()+"，入库的数据条数:{}", list.size());
        }
    }
}
