package com.alihealth.d2d.provtest.service.impl;

import com.alihealth.d2d.provtest.entity.VTTSEventS;
import com.alihealth.d2d.provtest.factory.EventHandlerFactory;
import com.alihealth.d2d.provtest.service.handle.EventDataHandler;
import com.alihealth.d2d.provtest.utils.EventPojo;
import lombok.RequiredArgsConstructor;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

/**
 * @author Jason 事件主处理服务
 * @date 2025年06月05日 11:28:56
 */
@Service("eventProcessingService")
@RequiredArgsConstructor
public class EventProcessingServiceImpl {

    private final XmlParserServiceImpl xmlParserServiceImpl;
    private final EventHandlerFactory handlerFactory;

    /**
     * 解析xml并处理接收的事件
     * @param eventPojo
     * @param xml
     * @param eventId
     */
    @Async
    public void processEvent(EventPojo eventPojo, String xml,String eventId)  {
        EventDataHandler handler = handlerFactory.getHandler(eventPojo.getSubType());
        if(eventPojo.getSubType().startsWith("20")) {//应用数据
            VTTSEventS eventS = null;
            try {
                eventS = xmlParserServiceImpl.parseAppDataXml(xml);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            handler.handle(eventS);
        }else{
            handler.handleBase(xml,eventId);
        }

    }

}
